;
; QuickSurf AutoLISP Utility
;
; (c) Copyright 1988 Schreiber Instruments
;
; Simple grid and contour generation based on extracted points, shapes,
; and inserts; smoothing, hatchuring, labeling, 3d rotation.

(vmon)

; Extractor
(defun c:qsx ( / p1 p2 i)
	(enter)
	(setq
		fname (if (and fname (> (strlen fname) 0)) fname
			(getvar "DWGNAME"))
		i (getstring (strcat "File name <" fname ">: "))
		fname (if (and i (> (strlen i) 0)) i fname)
		p1 (getpoint "\nFirst corner of area <MAX>: ")
		p2 (if p1 (getcorner p1 "\nSecond corner of area: ") nil)
	)
	(extractor fname p1 p2 nil nil)
	(leave)
)

(defun setentypes ()
	(if (not entypes) (setq entypes (list
		"POINT" "SHAPE" "INSERT")))
)

(defun extractor (fnm p1 p2 pp1 pp2 / sset i j n etype ent z)
	(setentypes)
	(setq sset (if (and pp1 pp2) (ssget "c" pp1 pp2) (ssget))
		n (if sset (sslength sset) 0) i 0 j 0
	)
	(if (> n 0) (progn
		(prompt "\nWait ...")
		(if qfile (close qfile))
		(setq qfile nil qfile (open (strcat fnm ".qs") "wa"))
		(if qfile (progn
			(if (and p1 p2)
				(print (list (car p1) (cadr p1)
					(car p2) (cadr p2)) qfile)
			)
			(while (< i n)
				(if
	(member (cdr (assoc 0 (setq ent (entget (ssname sset i))))) entypes)
				(progn
					(setq j (1+ j))
					(print j)
	(print (append (cdr (assoc 10 (arc2l ent)))
		(list (if (setq z (assoc 38 ent)) (cdr z) 0))) qfile))
				)
				(setq i (1+ i))
			)
			(close qfile)
			(setq qfile nil)
		) (prompt (strcat "\nCan't open file '" fname "' "))
		)
	))
)

; Polyline Extractor
(defun c:qsxpl ( / p1 p2 i)
	(enter)
	(setq
		fname (if (and fname (> (strlen fname) 0)) fname
			(getvar "DWGNAME"))
		i (getstring (strcat "File name <" fname ">: "))
		fname (if (and i (> (strlen i) 0)) i fname)
		p1 (getpoint "\nFirst corner of area <MAX>: ")
		p2 (if p1 (getcorner p1 "\nSecond corner of area: ") nil)
	)
	(extractpl fname p1 p2 nil nil)
	(leave)
)

(defun extractpl (fnm p1 p2 pp1 pp2 / )
	(setq sset (if (and pp1 pp2) (ssget "c" pp1 pp2) (ssget))
		n (if sset (sslength sset) 0) i 0 j 0
	)
	(if (> n 0) (progn
		(prompt "\nWait ...")
		(if qfile (close qfile))
		(setq qfile nil qfile (open (strcat fnm ".qs") "wa"))
		(if qfile (progn
			(if (and p1 p2)
				(print (list (car p1) (cadr p1)
					(car p2) (cadr p2)) qfile)
			)
			(while (< i n)
				(if
	(= "POLYLINE" (cdr (assoc 0 (setq ent (entget (ssname sset i))))))
					(progn
						(setq z (assoc 38 ent)
							z (if z (cdr z) 0)
						)
(while (= "VERTEX" (cdr (assoc 0 (setq ent (entget (entnext (cdr (assoc -1 ent))))))))
		(print (append (cdr (assoc 10 ent))
			(list (if (setq zz (assoc 38 ent)) (cdr zz) z))) qfile)
		(setq j (1+ j))
)
					)
				)
				(print (list (setq i (1+ i)) j))
			)
			(close qfile)
			(setq qfile nil)
		) (prompt (strcat "\nCan't open file '" fname "' "))
		)
	))
)

; Call QuickSurf.exe
(defun c:qs ( / cstring tmp )
	(setq cstring (if gridcells (strcat "qs -n" (itoa gridcells)) "qs"))
	(if (and clayer (not suppress))
		 (setq cstring (strcat cstring " -c" clayer)))
	(if interval (setq cstring (strcat cstring " -z" (rtos interval))))
	(if glayer (setq cstring (strcat cstring " -g" glayer)))
	(if player (setq cstring (strcat cstring " -p" player)))
	(if tlayer (setq cstring (strcat cstring " -t" tlayer)))
	(if (not fname) (setq fname (getvar "dwgname")))
	(setq tmp (getstring (strcat "File name <" fname ">: ")))
	(setq fname (if (and tmp (> (strlen tmp) 0)) tmp fname))
	(if suppress (setq cstring (strcat cstring " -")))
	(command
		"shell" (strcat cstring " " fname)
		"dxfin" fname
	)
)

; Post elevations
(defun c:post ( / sset n i pt p etype ent z tem)
	(enter)
	(setq sset (ssget) n (sslength sset) i 0 pt nil)
	(setentypes)
	(while (< i n)
		(if
			(member (cdr (assoc 0
				(setq ent (entget (ssname sset i)))))
				entypes)
			(progn
				(setq p (cdr (assoc 10 ent))
					z (assoc 38 ent)
					z (if z (cdr z) 0)
				)
				(if (not pt)
					(setq
		pt (getpoint p "\nText position: ")
		pt (if pt pt p)
		labelhi (if labelhi labelhi 0.2)
		tem (getdist pt (strcat "\nText height <"
			(rtos labelhi) ">: "))
		labelhi (if tem tem labelhi)
		pt (list (- (car pt) (car p)) (- (cadr pt) (cadr p)))
		player (if (and player (> (strlen player) 0)) player "POST")
		tem (getstring (strcat "Layer <" player ">: "))
		player (if (and tem (> (strlen tem) 0)) tem player)
		tem (command "layer" "t" player "m" player "")
					)
				)
				(command "elev" z 0
					"text" (list (+ (car p) (car pt))
					(+ (cadr p) (cadr pt))) labelhi 0
						(labform z)
				)
			)
		)
		(setq i (1+ i))
	)
	(leave)
)

; Random number generator
(defun ran ()
	(setq seed (if seed (rem (+ (* seed 15625.7) 0.21137152) 1) 0.3171943)))

; Test data generator for QS
(defun c:gen ( / n)
	(enter)
	(setq n (getint "\nNumber of points: "))
	(while (> n 0)
		(command "POINT" (list (* 13 (ran)) (* 8.75 (ran)) (* 3 (ran))))
		(setq n (1- n))
	)
	(leave)
)

; Hatchure polylines
(defun c:tick ( / ss n i ent ename p)
	(enter)
	(setq ss (ssget) n (if ss (sslength ss) 0) i (1- n) p nil)
	(while (and (<= 0 i) (not p))
		(if (= "POLYLINE" (cdr (assoc 0 (entget (setq ename
				(ssname ss i)))))) (progn
			(setq p (entget (entnext ename)))
			(while (and (assoc 70 p) (= 16 (boole 1 16
					(cdr (assoc 70 p)))))
				(setq p (entget (entnext (cdr (assoc -1 p)))))
			)
			(setq p (cdr (assoc 10 p)))
		))
		(setq i (1- i))
	)
	(if p (progn
		(setq
			tickdist (if tickdist tickdist 0.25)
			ticklen (if ticklen ticklen 0.0625)
			i (getdist p (strcat "\nDistance between ticks <"
				(rtos tickdist) ">: "))
			tickdist (if i i tickdist)
			i (getdist p (strcat "\nLength of ticks <"
				(rtos ticklen) ">: "))
			ticklen (if i i ticklen)
			i 0
		)
		(while (< i n)
			(if (= "POLYLINE" (cdr (assoc 0 (setq ent (entget
				(ssname ss i))))))
				(ticker ent)
			)
			(setq i (1+ i))
		)
	) (prompt "No contours found"))
	(leave)
)

; Smoothing of polylines
(defun c:smooth ( / ss i n ename tmp)
	(enter)
	(if (not howsmooth) (setq howsmooth (if pause "s" "f")))
	(if pause (setvar "splinesegs" -1))
	(setq ss (ssget) n (sslength ss) i 0)
	(while (< i n)
		(if (= "POLYLINE" (cdr (assoc 0 (entget (setq ename
			(ssname ss i))))))
			(command "pedit" ename howsmooth "")
		)
		(setq i (1+ i))
	)
	(leave)
)

; Function entry
(defun enter ()
	(setq
		clay (getvar "CLAYER")
		ccol (getvar "CECOLOR")
		cele (getvar "ELEVATION")
		cgri (getvar "GRIDMODE")
	)
	(setvar "CMDECHO" 0)
	(setvar "BLIPMODE" 0)
	(setvar "GRIDMODE" 0)
)

; Function exit
(defun leave ()
	(command
		"layer" "s" clay ""
		"color" (if (= "BYLAYER" ccol) ccol (atoi ccol))
		"elev" cele ""
	)
	(setvar "BLIPMODE" 1)
	(setvar "GRIDMODE" cgri)
)

; Tick generator
(defun ticker (ent /
		dpat closed inner x0 y0 x1 y1 closed r dx dy dd dpat dline
		alfa beta xc yc a1 a2 da da0 rd dx0 dy0 dxd dyd x y
	)
	(command "layer" "s" (cdr (assoc 8 ent)) "")
	(if (assoc 62 ent) (command "color" (cdr (assoc 62 ent))))
	(command "elev" (if (assoc 38 ent) (cdr (assoc 38 ent)) 0.0) 0.0)
	(setq
		dpat (* 0.5 tickdist)
		closed (= 1 (boole 1 1 (cdr (assoc 70 ent))))
		ent (entget (entnext (cdr (assoc -1 ent))))
		inner (= "VERTEX" (cdr (assoc 0 ent)))
	)
	(while
		(and inner (= 16 (boole 1 16 (cdr (assoc 70 ent)))))
		(setq
			ent (entget (entnext (cdr (assoc -1 ent))))
			inner (= "VERTEX" (cdr (assoc 0 ent)))
		)
	)
	(setq
		y1 (cdr (assoc 10 ent))
		closed (if closed y1 nil)
		x1 (car y1)
		y1 (cadr y1)
		r (assoc 42 ent)
	)
	(setq
		ent (entget (entnext (cdr (assoc -1 ent))))
		inner (= "VERTEX" (cdr (assoc 0 ent)))
	)
	(while
		(and inner (= 16 (boole 1 16 (cdr (assoc 70 ent)))))
		(setq
			ent (entget (entnext (cdr (assoc -1 ent))))
			inner (= "VERTEX" (cdr (assoc 0 ent)))
		)
	)
	(while
		(or inner closed)
		(setq x0 x1 y0 y1)
		(if inner
			(setq y1 (cdr (assoc 10 ent)))
			(setq y1 closed closed nil)
		)
		(setq
			x1 (car y1)
			y1 (cadr y1)
			dx (- x1 x0)
			dy (- y1 y0)
			dline (sqrt (+ (* dx dx) (* dy dy)))
			dd (if (= 0.0 dline) 1 dline)
			r (cdr r)
			r (if (/= 0.0 r) r nil)
		)
		(if r
			(setq
				alfa (atan r)
				r (/ (* r dd 0.25) (square (sin alfa)))
				beta (- (+ (atan dy dx) (* 0.5 pi))
					(+ alfa alfa))
				xc (+ x0 (* r (cos beta)))
				yc (+ y0 (* r (sin beta)))
				a1 (- beta pi)
				a2 (+ a1 (* 4 alfa))
				da (/ tickdist r)
				da0 (/ dpat r)
				rd (- r ticklen)
				dline (* r (- a2 a1))
			)
			(setq
				dx (/ dx dd)
				dy (/ dy dd)
				dx0 (* dx dpat)
				dy0 (* dy dpat)
				dxd (- (* dy ticklen))
				dyd (* dx ticklen)
				dx (* dx tickdist)
				dy (* dy tickdist)
			)
		)
		(while (< dpat dline)
			(if r
				(setq 
					a1 (+ a1 da0)
					da0 da
					x (cos a1)
					y (sin a1)
					x0 (+ xc (* r x))
					y0 (+ yc (* r y))
					x (+ xc (* rd x))
					y (+ yc (* rd y))
				)
				(setq
					x0 (+ x0 dx0)
					y0 (+ y0 dy0)
					dx0 dx
					dy0 dy
					x (+ x0 dxd)
					y (+ y0 dyd)
				)
			)
			(command "line" (list x0 y0) (list x y) "")
			(setq dline (- dline dpat) dpat tickdist)
		)
		(setq
			dpat (- dpat dline)
			r (assoc 42 ent)
		)
		(if inner
			(setq
				ent (entget (entnext (cdr (assoc -1 ent))))
				inner (= "VERTEX" (cdr (assoc 0 ent)))
			)
		)
		(while
			(and inner (= 16 (boole 1 16 (cdr (assoc 70 ent)))))
			(setq
				r (assoc 42 ent)
				ent (entget (entnext (cdr (assoc -1 ent))))
				inner (= "VERTEX" (cdr (assoc 0 ent)))
			)
		)
	)
)

(defun square (x) (* x x))

; Distance between two points (2d)
(defun vlen (a b) (sqrt (+ (square (- (car a) (car b)))
		(square (- (cadr a) (cadr b))))))

; Convert arc entity to a line entity
(defun arc2l (ent / x0 y0 x1 y1)
	(if (= "ARC" (cdr (assoc 0 ent)))
		(setq
			x0 (+ (cadr (assoc 10 ent))
	(* (cdr (assoc 40 ent)) (cos (cdr (assoc 50 ent)))))
			y0 (+ (caddr (assoc 10 ent))
	(* (cdr (assoc 40 ent)) (sin (cdr (assoc 50 ent)))))
			x1 (+ (cadr (assoc 10 ent))
	(* (cdr (assoc 40 ent)) (cos (cdr (assoc 51 ent)))))
			y1 (+ (caddr (assoc 10 ent))
	(* (cdr (assoc 40 ent)) (sin (cdr (assoc 51 ent)))))
			ent
	(subst (list 10 x0 y0) (assoc 10 ent)
	(subst (list 11 x1 y1) (assoc 50 ent)
	(subst (cons 0 "LINE") (cons 0 "ARC") ent)))
		)
	)
	ent
)

; Indexing of polylines
(defun c:index ( / ss i n ename tmp)
	(enter)
	(if (not howwide) (setq howwide 0.0075))
	(setq i (getdist (strcat "Line width <" (rtos howwide) ">: ")))
	(if i (setq howwide i))
	(setq ss (ssget) n (sslength ss) i 0)
	(while (< i n)
		(if (= "POLYLINE" (cdr (assoc 0 (entget (setq ename
			(ssname ss i))))))
			(command "pedit" ename "w" howwide "")
		)
		(setq i (1+ i))
	)
	(leave)
)

; Contour labeling
(defun c:label ( /
	p qlist r n ename ent tem
	)
	(enter)
	(setq p nil qlist (list) r (* 0.01 (getvar "viewsize")) n 0)
	(while (setq ent (getpoint "\nLabel location: "))
		(setq
			p ent
			qlist (append qlist (list p))
			n (1+ n)
		)
		(command "circle" p r)
	)
	(if p (progn
		(command "undo" n)
		(setq
			labelhi (if labelhi labelhi 0.2)
			tem (getdist p (strcat "\nText height <"
				(rtos labelhi) ">: "))
			labelhi (if tem tem labelhi)
		)
		(while (car qlist)
			(setq ent (ssget (setq p (car qlist))))
			(if ent (progn
				(setq ent (entget (setq ename (ssname ent 0))))
				(if (= "POLYLINE" (cdr (assoc 0 ent)))
					(labeler (list ename p))
				)
			))
			(setq qlist (cdr qlist))
		)
	))
	(leave)
)

; Label formatting - as short as possible
(defun labform (x / l)
	(setq x (rtos x) l (strlen x))
	(if (and (> l 4) (= "E" (substr x (- l 3) 1)))
		(while (= "0" (substr x (- l 4) 1))
			(setq
				x (strcat (substr x 1 (- l 5))
					(substr x (- l 3)))
				l (1- l))
			)
		(while (and (= "0" (substr x l)) (> l 1))
			(setq l (1- l) x (substr x 1 l)))
	)
	(if (= "." (substr x l)) (setq x (substr x 1 (1- l))))
	x
)

; Label generator
(defun labeler (es /
	ent ename p ele elet entc ent1 ent2 llast p1 p2 r r1 r2
	closed ent1 ent2 llast p1 p2 r1 r2 p11
	)
	(if (= "POLYLINE" (cdr (assoc 0 (setq ent (entget (setq ename
			(car es))))))) (progn
		(command
			"undo" "g"
			"layer" "s" (cdr (assoc 8 ent)) ""
		)
		(if (assoc 62 ent) (command "color" (cdr (assoc 62 ent))))
		(setq
			p (cadr es)
			ele (assoc 38 ent)
			ele (if ele (cdr ele) 0.0)
			elet (labform ele)
			r (* 0.5 labelhi (strlen elet))
			closed (= 1 (boole 1 1 (cdr (assoc 70 ent))))
		)
		(command
			"elev" ele 0.0
			"circle" p r
			"trim" "l" "" es ""
		)
		(setq
			r (* 0.99 r)
			entc (entget (ssname (ssget "p") 0))
			ent1 (entnext (cdr (assoc -1 entc)))
			ent1 (if ent1 (entget ent1) nil)
			ent2 (entget (ssname (ssget "l") 0))
			ent2 (if (and ent1 (not (equal ent1 ent2))) ent2 nil)
			llast nil
		)
		(if ent1 (progn
			(setq p1 (cdr (assoc 10 (arc2l (entget (entnext (cdr
					(assoc -1 ent1))))))))
			(command "undo" "m" "explode" (cdr (assoc -1 ent1)))
			(setq llast (arc2l (entget (ssname (ssget "l") 0))))
			(command "undo" "b")
			(setq
				p2 (cdr (assoc 11 llast))
				r1 (vlen p p1)
				r2 (vlen p p2)
			)
		))
		(cond (ent2 (progn
			(setq
				p1 (cdr (assoc 11 llast))
				p2 (cdr (assoc 10 (arc2l (entget (entnext (cdr
					(assoc -1 ent2)))))))
				)
			(if closed (command "pedit" (cdr (assoc -1 ent1)) "j"
				(cdr (assoc -1 ent2)) "" ""))
			))
			((not ent1) (progn
		(command "erase" (cdr (assoc -1 ent)) "")
		(setq p1 (list (+ (car p) 1.0) (cadr p)) p2 p1)
			))
			((< r2 r) (progn
				(command "trim" (cdr (assoc -1 entc)) "" p2 "")
				(setq ent1 (entget (ssname (ssget "l") 0)))
				(command "undo" "m" "explode" "l")
				(setq
					llast (arc2l (entget (ssname
						(ssget "l") 0)))
					p2 (cdr (assoc 11 llast))
				)
				(command "undo" "b")
			))
			((< r1 r) (progn
				(setq
					p11 (cdr (assoc 10 (arc2l (entget
					(entnext (entnext (cdr
					(assoc -1 ent1))))))))
				)
				(while (> (vlen p p11) r) (setq p11 (list
					(* 0.5 (+ (car p1) (car p11)))
					(* 0.5 (+ (cadr p1) (cadr p11)))))
				)
				(command "trim" (cdr (assoc -1 entc)) "" p11 "")
				(setq
					ent1 (entget (ssname (ssget "l") 0))
					p1 (cdr (assoc 10 (arc2l (entget
						(entnext (cdr
						(assoc -1 ent1)))))))
				)
			))
			((< r1 r2) (progn
				(setq
					p2 (list
						(- (* 2 (car p)) (car p1))
						(- (* 2 (cadr p)) (cadr p1)))
				)
			))
			((< r2 r1) (progn
				(setq
					p1 (list
						(- (* 2 (car p)) (car p2))
						(- (* 2 (cadr p)) (cadr p2)))
				)
			))
		)
		(command "erase" (cdr (assoc -1 entc)) "")
		(if p1 (progn
			(if (> (car p1) (car p2)) (setq tem p2 p2 p1 p1 tem))
			(setq p2 (list
				(+ (car p) (- (car p2) (car p1)))
				(+ (cadr p) (- (cadr p2) (cadr p1))))
			)
			(command "text" "m" p labelhi p2 elet)
		))
		(command "undo" "e")
	))
)

; Error termination
(defun *ERROR* (st)
	(moder)
	(terpri)
	(princ "\nerror: ")
	(prompt (strcat st "\n"))
)

; Rotate selected objects to present vpoint
(defun c:tilt ( / x y z i n sine cosi angle sset ename ent etype x1 y1 k)
	(enter)
	(setq x (getvar "VPOINTX") y (getvar "VPOINTY"))
	(if (or (/= x 0.0) (/= y 0.0))
	(progn
	(setq
		z (getvar "VPOINTZ")
		i (+ (* x x) (* y y))
		n (sqrt (+ i (* z z)))
		i (sqrt i)
		sine (/ i n)
		cosi (/ z n)
		angle (- (+ 90.0 (* 180.0 (/ (atan y x) pi))))
		sset (ssget)
		n (if sset (sslength sset) 0)
		i 0
	)
	(if (> n 0) (progn
	(command "rotate" sset "" "0,0" angle)
	(while (< i n)
		(setq
			ename (ssname sset i)
			ent (entget ename)
			etype (cdr (assoc 0 ent))
			i (1+ i)
		)
		(cond
			((or
				(= etype "POINT")
				(= etype "SHAPE")
				(= etype "TEXT")
				(= etype "INSERT")
				(= etype "ATTDEF")
				(= etype "ATTRIB"))
				(progn
					(setq
						z (assoc 38 ent)
						z (if z (cdr z) 0.0)
						x (cdr (assoc 10 ent))
						y (cadr x)
						x (car x)
						ent (subst
	(cons 10 (list x (+ (* cosi y) (* sine z))))
							(assoc 10 ent) ent)
						ent (if z (subst
	(cons 38 (- (* cosi z) (* sine y)))
							(assoc 38 ent) ent)
							(append ent 
	(list (cons 38 (+ (* sine y) (* cosi z)))))
						)
					)
					(entmod ent) ;(entupd ename)
				)
			)
			((or (= etype "3DFACE") (= etype "3DLINE")) (progn
				(setq k (if (= etype "3DFACE") 13 11))
				(while (> k 9)
					(setq
						z (cdr (assoc k ent))
						x (car z)
						y (cadr z)
						z (caddr z)
						ent (subst
	(cons k (list x (+ (* cosi y) (* sine z)) (- (* cosi z) (* sine y))))
							(assoc k ent) ent)
						k (1- k)
					)
				)
					(entmod ent) ;(entupd ename)
				)
			)
			((= etype "LINE") (progn
				(setq
					z (assoc 38 ent)
					z (if z (cdr z) 0.0)
					x (cdr (assoc 10 ent))
					y (cadr x)
					x (car x)
					x1 (cdr (assoc 11 ent))
					y1 (cadr x1)
					x1 (car x1)
				)
				(command
	"erase" ename ""
	"3dline" (list x (+ (* cosi y) (* sine z)) (- (* cosi z) (* sine y)))
	(list x1 (+ (* cosi y1) (* sine z)) (- (* cosi z) (* sine y1))) ""
				)
			))
			(T nil)
		)
	)))) (princ "Doesn't do anything in plan view."))
	(leave)
	(princ)
)

(princ)
